#include "main.h"


void order_moves (board * B)
{
    int i, j, p, sz;
    int val;
    int mv;
    int _from, _to, _flags;
    int _piece;
    U64 att, k, occ;

    int values [256];

    int hash_move = 0;
    int pv_move = 0;

    //  pv   
    //pv_t * t = is_it_pv (B->hash, S->ply);
    //if (t != NULL) pv_move = t->mv;

    //     ,  
    hash_t * h = hash_get (B);
    if (h != NULL && h->age == g_hash_age) hash_move = h->move;

    sz = B->size;

    for (i = 0; i < sz; i ++)
    {
        values [i] = 0;

        mv     = B->moves [i];
        //printf ("%s\n", move_to_str (mv));

        _flags = (mv & 0x000000FF);
        _to    = (mv & 0x0000FF00) >> 8;
        _from  = (mv & 0x00FF0000) >> 16;
        _piece = (mv & 0xFF000000) >> 24;


        // history ////////////////////////////////

        values [i] += history [_from][_to];


        //       
        if (_piece == 0)
        {
            if (hori(_from) == 3) values [i] += o_pawn_4;
            if (hori(_from) == 2) values [i] += o_pawn_5;
            if (hori(_from) == 1) values [i] += o_pawn_6;
        };

        if (_piece == 1)
        {
            if (hori(_from) == 5) values [i] += o_pawn_4;
            if (hori(_from) == 6) values [i] += o_pawn_5;
            if (hori(_from) == 7) values [i] += o_pawn_6;
        };


        // pv /////////////////////////////////////


        if (pv_move && mv == pv_move)
        {
            //uci_send (" pv is here\n");

            values [i] += o_pv;
            continue;
        };



        // hash ///////////////////////////////////

        if (hash_move && mv == hash_move)
        {
            values [i] += o_hash;
            continue;
        };



        // promotions /////////////////////////////

        if (is_prom (_flags))
        {
            values [i] += o_prom;
            continue;
        };

        // captures ///////////////////////////////

        if (is_capture (_flags))
        {
            p = squares [_to];

            // MVV / LVA
            //val = (material [p] << 5) - material [_piece];

            // SEE
            val = see (mv);

            if      (val > 0) values [i] += o_good_cap + val;
            else if (val < 0) values [i] += o_bad_cap + val;

            continue;
        };

        // tactical moves & /////////////////////////
        // & evasions ///////////////////////////////

        val = 0;
        occ = occupied [0] | occupied [1];

        switch (_piece)
        {
            case BP: att = bpawn_att [_to];  break;
            case WP: att = wpawn_att [_to];  break;
            case BN: att = knight_att [_to]; break;
            case WN: att = knight_att [_to]; break;
            case BB: att = b_att (occ, _to); break;
            case WB: att = b_att (occ, _to); break;
            case BR: att = r_att (occ, _to); break;
            case WR: att = r_att (occ, _to); break;
            case BQ: att = q_att (occ, _to); break;
            case WQ: att = q_att (occ, _to); break;
            default: break;
        };

        att &= occupied [ (_piece & 1) ^ 1 ];


        while (att)
        {
            k = LSB (att);
            j = bitscan (k);

            val = material [squares [j]] >> 5;
            //if (val == w_k || val == b_k) break;
            values [i] += val;

            att ^= k;
        };


        /*
        if (val == w_k || val == b_k) //  )
        {
            values [i] = o_tactical;
            continue;
        };
        */



        if (val) values [i] += o_evasion;


        continue;

        // killers ////////////////////////////////

        if (mv == killers [S->ply][0])
        {
            values [i] += o_killer;
            continue;
        };

        if (mv == killers [S->ply][1])
        {
            values [i] += o_killer >> 1;
            continue;
        };
    };

    shell_sort ((int*)values, (int*)B->moves, sz);

    /*
    //    
    for (i = 0; i < sz - 1; i ++)
    {
        //uci_send ("%i\n", value [i]);
        if (values [i] < values [i+1])
        {
            uci_send ("ordering error!!! %i\n", sz);
            for (i = 0; i < sz; i ++)
            {
                uci_send ("%i\n", values [i]);
            };
        };
    };
    */
    //uci_send ("\n");

};

int do_move (int mv, int prom, board * B)
{
    int i, sz;
    int mask; //    

	if (prom) mask = 0x00FFFF03 | f_prom; //     
	else      mask = 0x00FFFF00;         //     !

    //  
    generate (B);

    sz = B->size;

    for (i = 0; i < sz; i ++)
    {
        //     
        if ((B->moves[i] & mask) == mv)
        {
            make_move (i, B, B);

            return 1;
        };
    };

    return 0;
};


int evaluate (board * B)
{
    //    <<   >>

    //        .    
    //  . ,  inline  ,      .
    //       .
    //        .    
    //    /   .

    // 1. 
    // 2.   PST ()
    // 3.  (     ,   )
    // 4.  
    // 5. 

	int i, j, n;
	int jj, pp, kk;
	int score;
	int count;
	U64 bb, bbb, t, t1, tt;
	U64 occ, empty;
	U64 not_black;
	U64 not_white;
	U64 blocker;
	U64 x64; //  popcount'
	U64 wh_sum, bl_sum; //        
	U64 wh_att, bl_att;  //   

	U64 w_pawns, b_pawns; //  
	//U64 w_def_pawns;     //  
	//U64 b_def_pawns;
	U64 passers;

	U64 seq011, seq0110, seq01110; //    

	U64 wk_safety, bk_safety;  //   
	U64 w_targets, b_targets; //  , 

	const U64 center     = (I << E4) | (I << E5) | (I << D4) | (I << D5);
	const U64 big_center = (I << C3) | (I << D3) | (I << E3) | (I << F3) |
                           (I << C4) |                         (I << F4) |
                           (I << C5) |                         (I << F5) |
                           (I << C6) | (I << D6) | (I << E6) | (I << F6);

    const U64 wh_half    = rank_1 | rank_2 | rank_3 | rank_4;
    const U64 bl_half    = rank_5 | rank_6 | rank_7 | rank_8;

	U64 b_opened_files, w_opened_files;

	int w_king_safe;
	int b_king_safe;

	int bq_is, wq_is;

	int wking_sq = bitscan (piece [WK]);
	int bking_sq = bitscan (piece [BK]);

	//int w_stage, b_stage; //      
	//int own_stage, opp_stage;

	const int center_cntrl  [] = {-9, 1, 10, 15, 17};
	const int bcenter_cntrl [] = {-6, -5, -3, 0, 1, 2, 3, 5, 6, 7, 8, 9, 10};

	const int doubled_cost  [] = {47, 47, 47, 33, 29, 20, 25, 11, 19};

    //    ()
    const int n_mob_forw    [] = {-3, -2, 0, 1, 2};
    const int b_mob_forw    [] = {-7, -1, -1, -1, 0, 0, 1, 2, 2, 3, 3, 4, 4, 5, 5};
    const int r_mob_forw    [] = {-3, -1, -1, 0, 0, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4};
    const int q_mob_forw    [] = {-1, -1, -1, 0, 0, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3};

    const int n_mob_back    [] = {-4, -2, -1, 0, 1};
    const int b_mob_back    [] = {-7, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
    const int r_mob_back    [] = {-5, -1, -1, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6};
    const int q_mob_back    [] = {-2, -1, 0, 0, 0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3};

    // 
    const int passer        [] = {0, 0, 1, 6, 16, 36, 76, 0};
    const int free_passer   [] = {0, 0, 1, 3, 7, 10, 16, 0}; // 
    const int def_passer    [] = {0, 0, 1, 2, 5, 8, 12, 0}; // 

    //     ,  
    const int pawn_pair     [] = {0, 0, 12, 22, 35, 48, 60, 200};
    const int pawn_tri      [] = {0, 0, 13, 22, 37, 50, 75, 300};

	//    :    - ,  
	//    ,   ,   ..  
	//    

    //   
	score = mat [1] - mat [0];

	b_king_safe = w_king_safe = 1;

	bl_sum = wh_sum = E;
	bq_is = wq_is = 0;

	occ = occupied [0] | occupied [1];
	empty = ~occ;

	not_black = ~occupied [0];
	not_white = ~occupied [1];

	wk_safety = king_att [bitscan (LSB (piece[WK]))];
	bk_safety = king_att [bitscan (LSB (piece[BK]))];

	w_pawns = piece [WP];
	b_pawns = piece [BP];

    //        ? ( )
    bq_is = piece [BQ] ? 1 : 0;
    wq_is = piece [WQ] ? 1 : 0;





    //  //////////////////////////////////////////////////////

	i = WK;
    bb = piece [i];

    //       f
    if (bb == (I << E1))
    {
        if (!(piece [WP] & (I << F2))) score -= 10;

        wh_att = occ & (c_mov_K | c_mov_Q);
        score -= busy_cast * (pop_count (wh_att));

        //        
        if (bq_is)
        {
            score -= uncastled;
            w_king_safe = 0;
        };
    };


    //  ( ,      )
    if (bb & (I << A1 | I << B1 | I << C1))
    {
        if (w_pawns & (I << A2 | I << B2)) score -= closed_king;
    };

    if (bb & (I << G1 | I << H1))
    {
        if (w_pawns & (I << G2 | I << H2)) score -= closed_king;
    };


    if (bq_is)
    {
        //   (         )
        if (!(bb & safe_squares_w))
        {
            w_king_safe = 0;

            if (!(B->castling_rights & c_K)) score -= lost_k_cast;
            if (!(B->castling_rights & c_Q)) score -= lost_q_cast;

        };

        //  
        if (bb & (file_d | file_e) || bb & (file_f | file_g | file_h))
        {
            if (!(w_pawns & (I << G2)))
            {
                score -= shld_miss_g;
                if (!(w_pawns & (I << G3))) score -= shld_miss_g >> 1;
            };

            if (!(w_pawns & (I << H2)))
            {
                score -= shld_miss_h;
                if (!(w_pawns & (I << H3))) score -= shld_miss_h >> 1;
            };

            if (!(w_pawns & (I << F2)))
            {
                score -= shld_miss_f;
                if (!(w_pawns & (I << F3))) score -= shld_miss_f >> 1;
            };

            if (!(w_pawns & file_f) && !(bb & (I << H1))) score -= shld_hole;
            if (!(w_pawns & file_g)) score -= shld_hole;
            if (!(w_pawns & file_h) && (bb & (I << H1))) score -= shld_hole;
        }
        else if (bb & (file_d | file_e) || bb & (file_a | file_b | file_c))
        {
            if (!(w_pawns & (I << B2)))
            {
                score -= shld_miss_b;
                if (!(w_pawns & (I << B3))) score -= shld_miss_b >> 1;
            };

            if (!(w_pawns & (I << A2)))
            {
                score -= shld_miss_a;
                if (!(w_pawns & (I << A3))) score -= shld_miss_a >> 1;
            };

            if (!(w_pawns & (I << C2)))
            {
                score -= shld_miss_c;
                if (!(w_pawns & (I << C3))) score -= shld_miss_c >> 1;
            };

            if (!(w_pawns & file_c) && !(bb & (I << A1))) score -= shld_hole;
            if (!(w_pawns & file_b)) score -= shld_hole;
            if (!(w_pawns & file_a) && (bb & (I << A1))) score -= shld_hole;
        };
    };



    t = LSB (bb);
    j = bitscan (t);

    //  
    if (bq_is) score += pst_km [j];
    else       score += pst_ke [j];

    //        (      )
    wk_safety = king_att [j];
    //score -= pop_count (wk_safety & bl_sum) * king_safety;








    ///////////////////////////////////////////////////////////////////////////////

    i = BK;
    bb = piece [i];

    //       f
    if (bb == (I << E8))
    {
        if (!(piece [BP] & (I << F7))) score += 10;

        bl_att = occ & (c_mov_k | c_mov_q);
        score += busy_cast * pop_count (bl_att);

        //        
        if (wq_is)
        {
            score += uncastled;
            b_king_safe = 0;
        };
    };


    //  ( ,      )
    if (bb & (I << A8 | I << B8 | I << C8))
    {
        if (b_pawns & (I << A7 | I << B7)) score += closed_king;
    };

    if (bb & (I << G8 | I << H8))
    {
        if (b_pawns & (I << G7 | I << H7)) score += closed_king;
    };


    if (wq_is)
    {
        //   (         )
        if (!(bb & safe_squares_b))
        {
            b_king_safe = 0;

            if (!(B->castling_rights & c_k)) score += lost_k_cast;
            if (!(B->castling_rights & c_q)) score += lost_q_cast;
        };

        //  
        if (bb & (file_d | file_e) || bb & (file_f | file_g | file_h))
        {
            if (!(b_pawns & (I << G7)))
            {
                score += shld_miss_g;
                if (!(b_pawns & (I << G6))) score += shld_miss_g >> 1;
            };

            if (!(b_pawns & (I << H7)))
            {
                score += shld_miss_h;
                if (!(b_pawns & (I << H6))) score += shld_miss_h >> 1;
            };

            if (!(b_pawns & (I << F7)))
            {
                score += shld_miss_f;
                if (!(b_pawns & (I << F6))) score += shld_miss_f >> 1;
            };

            if (!(b_pawns & file_f) && !(bb & (I << H8))) score += shld_hole;
            if (!(b_pawns & file_g)) score += shld_hole;
            if (!(b_pawns & file_h) && (bb & (I << H8))) score += shld_hole;
        }
        else if (bb & (file_d | file_e) || bb & (file_a | file_b | file_c))
        {
            if (!(b_pawns & (I << B7)))
            {
                score += shld_miss_b;
                if (!(b_pawns & (I << B6))) score += shld_miss_b >> 1;
            };

            if (!(b_pawns & (I << A7)))
            {
                score += shld_miss_a;
                if (!(b_pawns & (I << A6))) score += shld_miss_a >> 1;
            };

            if (!(b_pawns & (I << C7)))
            {
                score += shld_miss_c;
                if (!(b_pawns & (I << C6))) score += shld_miss_c >> 1;
            };

            if (!(b_pawns & file_c) && !(bb & (I << A8))) score += shld_hole;
            if (!(b_pawns & file_b)) score += shld_hole;
            if (!(b_pawns & file_a) && (bb & (I << A8))) score += shld_hole;
        };
    };

    t = LSB (bb);
    j = bitscan (t);

    //  
    if (wq_is)    score -= pst_km [j];
    else          score -= pst_ke [j];

    //        (      )
    bk_safety = king_att [j];
    //score += pop_count (bk_safety & wh_sum) * king_safety;









	//  ///////////////////////////////////////////////////////

    i = WP;
    bb = piece [i];
    count = pop_count (bb);

    // 
    t = bb;
    fill_up (t);

    t1 = bb;
    fill_dn (t1);

    w_opened_files = ~(t | t1);
    t <<= 8;

    // "All About Doubled Pawns" by IM Larry Kaufman
    n = pop_count (t & bb);
    score -=  n * (doubled_cost [count]);

    //  
    wh_att  = (bb & ~file_h) << 9;
	wh_att |= (bb & ~file_a) << 7;

    //   -   ,    
    //score += pawns_defended * pop_count (w_att & bb);

    //  
    score += center_cntrl  [pop_count (wh_att & center)];
    score += bcenter_cntrl [pop_count (wh_att & big_center)];

    //     -  
    b_targets = bb & (~wh_att) & (b_pawns >> 8);
    score -= (blocked >> 1) * pop_count (b_targets); // :  - 1/2,  - 0

    //     -   
    b_targets |= bb & (~wh_att) & ((occupied[0] ^ b_pawns) >> 8);
    score -= (blocked >> 1) * pop_count (b_targets); // :  - 1/2,  - 1/2

    //  
    t = ~w_opened_files;
    score -= isolated * pop_count_few ( bb & ( t ^ ( (t & (t << 1)) | (t & (t >> 1)) ) ) );

    //     -  
    seq011 = ~(bb << 1) & bb & (bb >> 1);     //  011 (  0110  01110)
    seq0110 = seq011 & ~(bb >> 2);             //     
    seq01110 = seq011 & (bb >> 2) & ~(bb >> 3); //     

    while (seq0110)
    {
        t = LSB (seq0110);
        j = bitscan (t);

        score += pawn_pair [hori(j)];

        seq0110 ^= t;
    };

    while (seq01110)
    {
        t = LSB (seq01110);
        j = bitscan (t);

        score += pawn_tri [hori(j)];

        seq01110 ^= t;
    };

    //    - 
    if (bb & bl_half) score += pawn_on_opp_side;


	wh_sum |= wh_att;


    //   
    bb &= occupied[1] >> 8;
    bb &= (rank_2 | rank_3) & (file_d | file_e);
    score -= blocked_pawn * pop_count (bb);

    /////////////////////////////////////

    i = BP;
    b_pawns = bb = piece [i];
    count = pop_count (bb);

    // 

    t = bb;
    fill_dn (t);

    t1 = bb;
    fill_up (t1);

    b_opened_files = ~(t | t1);
    t >>= 8;

    // "All About Doubled Pawns" by IM Larry Kaufman
    n = pop_count (t & bb);
    score -= - n * (doubled_cost [count]);

    //  
    bl_att  = (bb & ~file_h) >> 7;
    bl_att |= (bb & ~file_a) >> 9;

    //  
    //score -= pawns_defended * pop_count (b_att & bb);

    //  
    score -= center_cntrl  [pop_count (bl_att & center)];
    score -= bcenter_cntrl [pop_count (bl_att & big_center)];

    //     -  
    w_targets = bb & (~bl_att) & (w_pawns << 8);
    score += (blocked >> 1) * pop_count (w_targets); // :  - 1/2,  - 0

    //     -   
    w_targets |= bb & (~bl_att) & ((occupied[1] ^ w_pawns) << 8);
    score += (blocked >> 1) * pop_count (w_targets); // :  - 1/2,  - 1/2

    //  
    t = ~b_opened_files;
    score += isolated * pop_count_few ( bb & ( t ^ ( (t & (t << 1)) | (t & (t >> 1)) ) ) );

    //     -  
    seq011 = ~(bb << 1) & bb & (bb >> 1);     //  011 (  0110  01110)
    seq0110 = seq011 & ~(bb >> 2);             //     
    seq01110 = seq011 & (bb >> 2) & ~(bb >> 3); //     

    while (seq0110)
    {
        t = LSB (seq0110);
        j = bitscan (t);

        score -= pawn_pair [7 - hori(j)];

        seq0110 ^= t;
    };

    while (seq01110)
    {
        t = LSB (seq01110);
        j = bitscan (t);

        score -= pawn_tri [7 - hori(j)];

        seq01110 ^= t;
    };

    //    - 
    if (bb & wh_half) score -= pawn_on_opp_side;


    bl_sum |= bl_att;

    //   
    bb &= occupied[0] << 8;
    bb &= (rank_7 | rank_6) & (file_d | file_e);
    score += blocked_pawn * pop_count (bb);

    /////////////////////////////////////////////////////////////////////////////////////////////
    //
    //  

    //  ////////////////////////////////////////////////////////////////////////////////////

    //     - 
    bb = passers = w_pawns & b_opened_files;

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        score += passer [hori(j)];

        bb ^= t;
    };

    //  
    bb = passers & wh_att;

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        score += def_passer [hori(j)];

        bb ^= t;
    };

    //  
    bb = passers & (b_opened_files & (b_opened_files << 1) & (b_opened_files >> 1));

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        score += free_passer [hori(j)];

        bb ^= t;
    };

    // ׸ ///////////////////////////////////////////////////////////////////////////////////

    //     - 
    bb = passers = b_pawns & w_opened_files;

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        score -= passer [7 - hori(j)];

        bb ^= t;
    };

    //  
    bb = passers & bl_att;

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        score -= def_passer [7 - hori(j)];

        bb ^= t;
    };

    //  
    bb = passers & (w_opened_files & (w_opened_files << 1) & (w_opened_files >> 1));

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        score -= free_passer [7 - hori(j)];

        bb ^= t;
    };

	//  ////////////////////////////////////////////////////////

    i = WN;
    bb = piece [i];
    count = 0;

    // ,     ( )
    t = (b_pawns & rank_7) >> 24;
    t &= empty >> 8;
    t &= empty;
    t &= (bb << 1) | (bb >> 1);
    if (t) score -= knight_on_2pawn;

    // ,     ( )
    t = b_pawns >> 16;
    t &= empty;
    t &= (bb << 1) | (bb >> 1);
    if (t) score -= knight_on_pawn;

    //w_att = E;

    while (bb)
    {
        count ++;

        t = LSB (bb);
        j = bitscan (t);

        score += pst [i][j];

        wh_att = knight_att [j];

        //  
        if (w_king_safe)
        {
            score += pop_count (wh_att & b_targets) * on_target;
            score += pop_count (wh_att & bk_safety) * on_king;
        };

        // 
        score += n_trop [bking_sq][j];

        wh_sum |= wh_att;

        // 
        bbb = wh_att & not_white & ~bl_sum;
        score += n_mob_forw [pop_count (bbb & up_mask (j))];
        score += n_mob_back [pop_count (bbb & dn_mask (j))];

        bb ^= t;
    };

    /////////////////////////////////////

    i = BN;
    bb = piece [i];
    count = 0;

    // ,     ( )
    t = (w_pawns & rank_2) << 24;
    t &= empty << 8;
    t &= empty;
    t &= (bb << 1) | (bb >> 1);
    if (t) score += knight_on_2pawn;

    // ,     ( )
    t = w_pawns << 16;
    t &= empty;
    t &= (bb << 1) | (bb >> 1);
    if (t) score += knight_on_pawn;

    //b_att = E;

    while (bb)
    {
        count ++;

        t = LSB (bb);
        j = bitscan (t);

        score -= pst [i][j];

        bl_att = knight_att [j];

        //  
        if (b_king_safe)
        {
            score -= pop_count (bl_att & w_targets) * on_target;
            score -= pop_count (bl_att & wk_safety) * on_king;
        };

        // 
        score -= n_trop [wking_sq][j];

        bl_sum |= bl_att;

        // 
        bbb = bl_att & not_black & ~wh_sum;
        score -= n_mob_forw [pop_count (bbb & dn_mask (j))];
        score -= n_mob_back [pop_count (bbb & up_mask (j))];

        bb ^= t;
    };

	//  ///////////////////////////////////////////////////////

	i = WB;
    bb = piece [i];
    count = 0;

    //w_att = E;

    while (bb)
    {
        count ++;

        t = LSB (bb);
        j = bitscan (t);

        score += pst [i][j];
        // +  

        wh_att = b_att (occ, j);

        if (w_king_safe)
        {
            //  
            score += pop_count (wh_att & b_targets) * on_target;
            score += pop_count (wh_att & bk_safety) * on_king;

            // 
            blocker = wh_att & occ;
            bbb = b_att (occ ^ blocker, j) & occ;

            if (bbb && !blocker)
            {
                print_board (B);
                print_this_att (blocker);
                print_this_att (bbb);
            };

            while (bbb)
            {
                tt = LSB (bbb);
                jj = bitscan (tt);

                pp = squares [jj];
                if (pp == BR || pp == BQ)
                {
                    kk = squares [bitscan(blocker & link_att[j][jj])];
                    score += (is_white(kk)) ? disc_att : ppin_bonus;
                }
                else if (pp == BK)
                {
                    kk = squares [bitscan(blocker & link_att[j][jj])];
                    score += (is_white(kk)) ? disc_check : pin_bonus;
                };

                bbb ^= tt;
            };
        };

        // 
        score += b_trop [bking_sq][j];

        wh_sum |= wh_att;

        // 
        bbb = wh_att & not_white & ~bl_sum;
        score += b_mob_forw [pop_count (bbb & up_mask (j))];
        score += b_mob_back [pop_count (bbb & dn_mask (j))];

        bb ^= t;
    };

    if (count > 1) score += bishop_pair;

    /////////////////////////////////////

    i = BB;
    bb = piece [i];
    count = 0;

    //b_att = E;

    while (bb)
    {
        count ++;
        //score -= material [i];

        t = LSB (bb);
        j = bitscan (t);

        score -= pst [i][j];
        // +  

        bl_att = b_att (occ, j);

        if (b_king_safe)
        {
            //  
            score -= pop_count (bl_att & w_targets) * on_target;
            score -= pop_count (bl_att & wk_safety) * on_king;

            // 
            blocker = bl_att & occ;
            bbb = b_att (occ ^ blocker, j) & occ;

            if (bbb && !blocker)
            {
                print_board (B);
                print_this_att (blocker);
                print_this_att (bbb);
            };

            while (bbb)
            {
                tt = LSB (bbb);
                jj = bitscan (tt);

                pp = squares [jj];
                if (pp == WR || pp == WQ)
                {
                    kk = squares [bitscan(blocker & link_att[j][jj])];
                    score -= (is_black(kk)) ? disc_att : ppin_bonus;
                }
                else if (pp == WK)
                {
                    kk = squares [bitscan(blocker & link_att[j][jj])];
                    score -= (is_black(kk)) ? disc_check : pin_bonus;
                };

                bbb ^= tt;
            };
        };

        // 
        score -= b_trop [wking_sq][j];

        bl_sum |= bl_att;

        // 
        bbb = bl_att & not_black & ~wh_sum;
        score -= b_mob_forw [pop_count (bbb & dn_mask (j))];
        score -= b_mob_back [pop_count (bbb & up_mask (j))];

        bb ^= t;
    };

    if (count > 1) score -= bishop_pair;

	//  ///////////////////////////////////////////////////////

	i = WR;
    bb = piece [i];
    count = 0;

    score += pop_count_few (bb & w_opened_files & b_opened_files) * rook_on_opened;
    score += pop_count_few (bb & b_opened_files) * rook_on_semi;

    //w_att = E;

    while (bb)
    {
        count ++;
        //score += material [i];

        t = LSB (bb);
        j = bitscan (t);

        score += pst [i][j];
        // +  

        wh_att = r_att (occ, j);

        if (w_king_safe)
        {
            //  
            score += pop_count (wh_att & b_targets) * on_target;
            score += pop_count (wh_att & bk_safety) * on_king;

            // 
            blocker = wh_att & occ;
            bbb = r_att (occ ^ blocker, j) & occ;

            if (bbb && !blocker)
            {
                print_board (B);
                print_this_att (blocker);
                print_this_att (bbb);
            };

            while (bbb)
            {
                tt = LSB (bbb);
                jj = bitscan (tt);

                pp = squares [jj];
                if (pp == BQ)
                {
                    kk = squares [bitscan(blocker & link_att[j][jj])];
                    score += (is_white(kk)) ? disc_att : ppin_bonus;
                }
                else if (pp == BK)
                {
                    kk = squares [bitscan(blocker & link_att[j][jj])];
                    score += (is_white(kk)) ? disc_check : pin_bonus;
                };

                bbb ^= tt;
            };
        };

        // 
        score += r_trop [bking_sq][j];

        wh_sum |= wh_att;

        // 
        bbb = wh_att & not_white & ~bl_sum;
        score += r_mob_forw [pop_count (bbb & (U ^ dn_mask (j)))]; // <-> 
        score += r_mob_back [pop_count (bbb & dn_mask (j))];

        bb ^= t;
    };

    if (count == 2)
    {
        score -= linked_rooks * pop_count_few ( occupied [1] & link_att [j][bitscan(LSB(piece [i]))] );
    };

    /////////////////////////////////////

    i = BR;
    bb = piece [i];
    count = 0;

    score -= pop_count_few (bb & w_opened_files & b_opened_files) * rook_on_opened;
    score -= pop_count_few (bb & w_opened_files) * rook_on_semi;

    //b_att = E;

    while (bb)
    {
        count ++;

        t = LSB (bb);
        j = bitscan (t);

        score -= pst [i][j];
        // +  

        bl_att = r_att (occ, j);

        if (b_king_safe)
        {
            //  
            score -= pop_count (bl_att & w_targets) * on_target;
            score -= pop_count (bl_att & wk_safety) * on_king;

            // 
            blocker = bl_att & occ;
            bbb = r_att (occ ^ blocker, j) & occ;

            if (bbb && !blocker)
            {
                print_board (B);
                print_this_att (blocker);
                print_this_att (bbb);
            };

            while (bbb)
            {
                tt = LSB (bbb);
                jj = bitscan (tt);

                pp = squares [jj];
                if (pp == WQ)
                {
                    kk = squares [bitscan(blocker & link_att[j][jj])];
                    score -= (is_black(kk)) ? disc_att : ppin_bonus;
                }
                else if (pp == WK)
                {
                    kk = squares [bitscan(blocker & link_att[j][jj])];
                    score -= (is_black(kk)) ? disc_check : pin_bonus;
                };

                bbb ^= tt;
            };
        };

        // 
        score -= r_trop [wking_sq][j];

        bl_sum |= bl_att;

        // 
        bbb = bl_att & not_black & ~wh_sum;
        score -= r_mob_forw [pop_count (bbb & (U ^ up_mask (j)))];  // <-> 
        score -= r_mob_back [pop_count (bbb & up_mask (j))];

        bb ^= t;
    };

    //b_sum |= b_att;

    if (count == 2)
    {
        score += linked_rooks * pop_count_few ( occupied [0] & link_att [j][bitscan(LSB(piece [i]))] );
    };

	//  ///////////////////////////////////////////////////////

	i = WQ;
    bb = piece [i];

    //w_att = E;

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);

        score += pst [i][j];
        // +  

        wh_att = q_att (occ, j);

        //  
        if (w_king_safe)
        {
            score += pop_count (wh_att & b_targets) * on_target;
            score += pop_count (wh_att & bk_safety) * on_king;

            // 
            blocker = wh_att & occ;
            bbb = q_att (occ ^ blocker, j) & occ;

            if (bbb && !blocker)
            {
                print_board (B);
                print_this_att (blocker);
                print_this_att (bbb);
            };

            while (bbb)
            {
                tt = LSB (bbb);
                jj = bitscan (tt);

                pp = squares [jj];
                if (pp == BK)
                {
                    kk = squares [bitscan(blocker & link_att[j][jj])];
                    score += (is_white(kk)) ? disc_check : pin_bonus;
                };

                bbb ^= tt;
            };
        };

        // 
        score += q_trop [bking_sq][j];

        wh_sum |= wh_att;

        // 
        bbb = wh_att & not_white & ~bl_sum;
        score += q_mob_forw [pop_count (bbb & (U ^ dn_mask (j)))];  // <-> 
        score += q_mob_back [pop_count (bbb & dn_mask (j))];

        bb ^= t;
    };

    //w_sum |= w_att;

    /////////////////////////////////////

    i = BQ;
    bb = piece [i];
    //count = 0;

    //b_att = E;

    while (bb)
    {
        //count ++;
        //score -= material [i];

        t = LSB (bb);
        j = bitscan (t);

        score -= pst [i][j];
        // +  

        bl_att = q_att (occ, j);

        //  
        if (b_king_safe)
        {
            score -= pop_count (bl_att & w_targets) * on_target;
            score -= pop_count (bl_att & wk_safety) * on_king;

            // 
            blocker = bl_att & occ;
            bbb = q_att (occ ^ blocker, j) & occ;

            if (bbb && !blocker)
            {
                print_board (B);
                print_this_att (blocker);
                print_this_att (bbb);
            };

            while (bbb)
            {
                tt = LSB (bbb);
                jj = bitscan (tt);

                pp = squares [jj];
                if (pp == WK)
                {
                    kk = squares [bitscan(blocker & link_att[j][jj])];
                    score -= (is_black(kk)) ? disc_check : pin_bonus;
                };

                bbb ^= tt;
            };
        };

        // 
        score -= q_trop [wking_sq][j];

        bl_sum |= bl_att;

        // 
        bbb = bl_att & not_black & ~wh_sum;
        score -= q_mob_forw [pop_count (bbb & (U ^ up_mask (j)))];  // <-> 
        score -= q_mob_back [pop_count (bbb & up_mask (j))];

        bb ^= t;
    };

    //b_sum |= b_att;



    ////////////////////////////////////////////////////////////////

    //  
    score += tempo;

	if (!wtm) score = - score;

	//print_board (L);
	//uci_send ("%i\n", score);

	return score;
};

void fen_to_pos (const char * fen, board * B)
{
	int x = A8, t = 0;

	int a;
	char ch;

	reps_refresh ();

	for (a = 0; a < 12; a ++) piece [a] = E;

	B->castling_rights = 0;
	B->en_passant = 0; // ,    ( ,    -       )
	B->attacker = 0;
	B->check_is = 0;
	B->taken = no_p;
	S->count_moves = 0;
	S->fifty = 0;
	B->hash = E;
	B->size = 0;
	S->irreversible_ply = 0;

	wtm = 1;

	mat[0] = mat[1] = 0;


	////  
	for (;; fen ++)
	{
		if (x < 0) break;
		if (!(ch = *fen)) goto exit_f;
		if (ch == ' ') break;

		switch (ch)
		{
			case 'K': piece [WK] |= I << x; squares [x] = WK;                          x ++; t ++; break;
			case 'Q': piece [WQ] |= I << x; squares [x] = WQ; mat[1] += material [WQ]; x ++; t ++; break;

			case 'R': piece [WR] |= I << x; squares [x] = WR; mat[1] += material [WR]; x ++; t ++; break;
			case 'B': piece [WB] |= I << x; squares [x] = WB; mat[1] += material [WB]; x ++; t ++; break;
			case 'N': piece [WN] |= I << x; squares [x] = WN; mat[1] += material [WN]; x ++; t ++; break;
			case 'P': piece [WP] |= I << x; squares [x] = WP; mat[1] += material [WP]; x ++; t ++; break;

			case 'k': piece [BK] |= I << x; squares [x] = BK;                          x ++; t ++; break;
			case 'q': piece [BQ] |= I << x; squares [x] = BQ; mat[0] += material [BQ]; x ++; t ++; break;

			case 'r': piece [BR] |= I << x; squares [x] = BR; mat[0] += material [BR]; x ++; t ++; break;
			case 'b': piece [BB] |= I << x; squares [x] = BB; mat[0] += material [BB]; x ++; t ++; break;
			case 'n': piece [BN] |= I << x; squares [x] = BN; mat[0] += material [BN]; x ++; t ++; break;
			case 'p': piece [BP] |= I << x; squares [x] = BP; mat[0] += material [BP]; x ++; t ++; break;

			case '/': x ++; t ++; break;
			default : if (ch >= '1' && ch <= '8') {t += ch - '0'; x += ch - '0';}; break;
		};

		if (t > 8)
		{
			t = 0;
			x -= 0x10;
			x &= 0xF8;
		};
	};

	//  occupied   
	occupied[0] = E;
	occupied[1] = E;

	for (a = 0; a < 12; a ++) occupied[a & 1] |= piece [a];

	if (!*fen) goto exit_f;

	////  

	//  
	fen ++;
	ch = *fen;
	if (ch == 'w') wtm = 1;
	else if (ch == 'b') wtm = 0;
	else if (!ch) goto exit_f;


	//   
	fen ++;
	if (!*fen) goto exit_f;
	fen ++;

	for (;; fen ++)
	{
		ch = *fen;
		if (ch == ' ' || ch == '-') break;
		if (!ch) goto exit_f;

		switch (ch)
		{
			case 'K': B->castling_rights |= c_K; break;
			case 'Q': B->castling_rights |= c_Q; break;
			case 'k': B->castling_rights |= c_k; break;
			case 'q': B->castling_rights |= c_q; break;
		};
	};


	//     

	for (;ch <= 'a' || ch >= 'h'; fen ++)
	{
		ch = *fen;
		if (!ch) goto exit_f;
	};

	a = ch - 'a';
	B->en_passant = a;

	ch = *fen;
	if (!ch) goto exit_f;
	if (ch >= '1' && ch <= '8') // ,      3,  6
	{
		a = ch - '1';
		B->en_passant += a << 3;
	};

	//    50- 
	if (!*(++fen)) goto exit_f;
	if (!*(++fen)) goto exit_f;

	for (; ch = *fen; fen ++)
	{
		if (!ch) goto exit_f;
		if (ch >= '0' && ch <= '9')
		{
			S->fifty *= 10;
			S->fifty += ch - '0';
		}
		else break;
	};

	if (!*(fen++)) goto exit_f;

	//  
	for (; ch = *fen; fen ++)
	{
		if (!ch) goto exit_f;
		if (ch >= '0' && ch <= '9')
		{
			S->count_moves *= 10;
			S->count_moves += ch - '0';
			S->irreversible_ply = S->count_moves;
		}
		else break;
	};

exit_f:

	R[0].key = B->hash = hash_calc (B);
};

char* pos_to_fen (board * B)
{
    int  i;
    int  x = A8, t = 0;
    int  p, c = 0;      //   
    char str [25] = {0, };
    //char ch;
    char *pfen, *pstr;
    U64  bb;

    char *fen = new char [512];

    for (i = 0; i < 512; i ++) fen [i] = 0;

    pfen = fen;
    pstr = str;

    for (;;)
    {
        for (i = 0; i < 12; i ++)
        {
            bb = piece [i];

            if ((I << x) & bb) break;
        };

        //     break' -  
        if (i == 12) c ++;
        else
        {
            if (c) *(pfen ++) = c + '0';
            *(pfen ++) = piece_array [i];
            c = 0;
        };

        x ++;
        t ++;

        if (t >= 8)
        {
            t = 0;
			x -= 0x10;

			//x &= 0xF8;

			if (c)
			{
			    *(pfen ++) = c + '0';
                c = 0;
			};

			if (x < 0) break;

			*(pfen ++) = '/';
        };
    };

    //"rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1"

    *(pfen ++) = ' ';

    *(pfen ++) = wtm ? 'w' : 'b';

    *(pfen ++) = ' ';

    p = B->castling_rights;

    if (p & c_K) *(pfen ++) = 'K';
    if (p & c_Q) *(pfen ++) = 'Q';
    if (p & c_k) *(pfen ++) = 'k';
    if (p & c_q) *(pfen ++) = 'q';

    if (p) *(pfen ++) = ' ';

    p = B->en_passant;

    if (!p) *(pfen ++) = '-';
    else
    {
        *(pfen ++) = vert (p) + 'a';
        *(pfen ++) = hori (p) + '1';
    }

    *(pfen ++) = ' ';


    p = S->count_moves;
    if (p < 0 || p > 500) p = 0;

    sprintf (pfen, "%i %i \0", S->fifty, p);

    return fen;
};

U64 attacked_by (U64 occ, int sq) //      ?
{
    U64 bb;
    U64 rq, bq;  //    
    U64 kn, ki; // , 

    bb = E;

    rq = piece[BR] | piece[WR] | piece[BQ] | piece [WQ];
    bq = piece[BB] | piece[WB] | piece[BQ] | piece [WQ];
    kn = piece[BN] | piece[WN];
    ki = piece[BK] | piece[WK];

    bb |= r_att (occ, sq) & rq;
    bb |= b_att (occ, sq) & bq;
    bb |= knight_att [sq] & kn;
    bb |= wpawn_att [sq]  & piece [BP];
    bb |= bpawn_att [sq]  & piece [WP];
    bb |= king_att [sq]   & ki;

    return bb;
};


int print_board (board * B)
{
    static const char castl [16][5] = {"-", "K", "Q", "QK", "k", "kK", "kQ", "kQK",
                                       "q", "qK", "qQ", "qQK", "qk", "qkK", "qkQ", "qkQK"};

	int a, b, c, i;
	U64 t;

	for (a = 0; a <= 7; a ++)
	{
		uci_send ("\n");
		for (b = 0; b <= 7; b ++)
		{
			c = ((7 - a) << 3) + b;

			for (i = 0; i < 12; i ++)
			{
				t = piece [i];
				if (t & (I << c))
				{
					uci_send ("%c", piece_array [i]);
					break;
				};
			};
			if (i == 12) uci_send (".");
		};
	};
	uci_send ("\n");
	if (B->check_is) uci_send ("\ncheck!\n");

    uci_send ("\ncastling: %s\n", &castl [B->castling_rights][0]);

	//print_this_att (occupied[0]);
	//print_this_att (occupied[1]);

	return 0;
};

void print_moves (board * B)
{
	int sz, i, fl, ep;
	int _from, _to, _flags, _piece;
	int mv;

	sz = B->size;

	uci_send ("\n");

	for (i = 0; i < sz;) //  i -   uci_send () !!!
	{
		mv     = B->moves [i];

        _flags = (mv & 0x000000FF);
        _to    = (mv & 0x0000FF00) >> 8;
        _from  = (mv & 0x00FF0000) >> 16;
        _piece = (mv & 0xFF000000) >> 24;


		uci_send ("%3i >> %c", ++i, piece_array [_piece]);
		uci_send ("%c%c", 'a' + (vert (_from)), '1' + (hori (_from)));

		ep = is_ep(_flags);
		fl = is_capture(_flags) || ep;
		if (fl) uci_send ("x");

		uci_send ("%c%c", 'a' + (vert (_to)), '1' + (hori (_to)));

		if (!fl) uci_send (" ");
		if (ep) uci_send (" ep");

		uci_send ("\n\n");
	};
};

void build_mask  (board * B)
{
    int coords_att, coords_king;
    U64 king;

    king = piece [BK + wtm];

    coords_att  = B->attacker;    //  
    coords_king = bitscan (king); // 

    //    
    B->msk_bb = link_att [coords_att][coords_king];
    B->msk_bb |= I << coords_att;

    //print_board (L);
    //print_this_att (msk_bb);
};

void check_detection (board * B)
{
    int i, j, c;
    U64 att, king, queen, t_att;
    U64 occ;
    U64 bb, t;
    U64 rq, bq; //    
    U64 x64; //  popcount'

    B->check_is = 0;
    B->attacker = 0;


    queen = piece [BQ + !wtm];

    rq = queen | piece [BR + !wtm];
    bq = queen | piece [BB + !wtm];

    occ = occupied [0] | occupied [1];

    king = piece [BK + wtm];
    c = bitscan (king);

    //      ///////////////////////////
    att = r_att (occ, c);
    //att &= occ;

    // ,      
    att &= rq; //  rq     occ?

    t_att = att; //   

    //      ///////////////////////////
    att = b_att (occ, c);
    //att &= occ;

    // ,      
    att &= bq;

    t_att |= att; //    
    /*if (t_att)*/ B->attacker = bitscan (t_att);

    B->check_is = pop_count (t_att);
    //if (check_is > 1) return;

    //  (    -      )
    i = !wtm;
    bb = piece [i];

    if (wtm)
    {
        att  = (bb & ~file_h) >> 7;
        att |= (bb & ~file_a) >> 9;

        if (att & king)
        {
            B->check_is ++;

            j = bitscan (king);
            t = wpawn_att [j];
            t &= bb;

            B->attacker = bitscan (t);
        };
    }
    else
    {
        att  = (bb & ~file_h) << 9;
        att |= (bb & ~file_a) << 7;

        if (att & king)
        {
            B->check_is ++;
            //att_type = i;

            j = bitscan (king);
            t = bpawn_att [j];
            t &= bb;

            B->attacker = bitscan (t);
        };
    };


    // 
    i += 2;
    bb = piece [i];

    while (bb)
    {
        t = LSB (bb);
        j = bitscan (t);
        att = knight_att [j];

        if (att & king)
        {
            B->check_is ++;
            B->attacker = j;
        };

        bb ^= t;
    };

    // 
    i = BK + !wtm;
    bb = piece [i];

    t = LSB (bb);
    j = bitscan (t);
    att = king_att [j];

    if (att & king)
    {
        B->check_is ++;
        B->attacker = j;
    };

    return;
};

inline int generate (board * B)
{
    int k_cast;
    int q_cast;
    int i, j, k;          //  , , 
    int m;               //    generate_proms ()
    int ep;
    U64 bb;
    U64 t, p, att, occ;
    U64 occ_own, occ_opp;
    U64 ca_k, ca_q;       //  ,  
    U64 cm_k, cm_q;       // ,  


    B->msk_bb = U;

    //      
    //pin_bb = E;
    //att_bb = E;

    B->taken = no_p;

    B->size = 0;

    occ_own = occupied [wtm];
    occ_opp = occupied [!wtm];

    occ = occ_own | occ_opp;

    ///////////////////////
    check_detection (B);
    //int temp = check_is;
    //build_att (L);
    //if (temp != check_is) uci_send ("yyyyyyy !!!!!!!!!!!!!!!!!!!!!!!!!!\n");
    ///////////////////////

    k_cast = king_cast [wtm];
    q_cast = queen_cast [wtm];

    ca_k = (wtm) ? c_att_K : c_att_k;
    ca_q = (wtm) ? c_att_Q : c_att_q;

    cm_k = (wtm) ? c_mov_K : c_mov_k;
    cm_q = (wtm) ? c_mov_Q : c_mov_q;


    //  (    )
    i = BK + wtm;

    bb = piece [i];
    j = bitscan (bb);

    att = king_att [j];
    att &= ~occ_own;     //     

    while (att)
    {
        t = LSB (att);
        k = bitscan (t);

        generate_moves (i, j, k, (t & occ_opp) ? f_capture : 0, B);

        att ^= t;
    };


    if (B->check_is > 0)
    {
        if (B->check_is > 1) return B->size;
        //    -   
        //      

        build_mask (B);
    };


    // 
    if ((B->castling_rights & k_cast)  &&
        (!(occ & cm_k)))
    {
        generate_moves (i, j, j + 2, f_castling, B);
    };

    if ((B->castling_rights & q_cast)  &&
        (!(occ & cm_q)))
    {
        generate_moves (i, j, j - 2, f_castling, B);
    };


    // 
    i -= 2;

    bb = piece [i];
    while (bb)
    {
        p = LSB (bb);
        j = bitscan (p);

        att = q_att (occ, j);
        att &= ~occ_own;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, (t & occ_opp) ? f_capture : 0, B);

            att ^= t;
        };

        bb ^= p;
    };


    // 
    i -= 2;

    bb = piece [i];
    while (bb)
    {
        p = LSB (bb);
        j = bitscan (p);

        att = r_att (occ, j);
        att &= ~occ_own;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, (t & occ_opp) ? f_capture : 0, B);

            att ^= t;
        };

        bb ^= p;
    };

    // 
    i -= 2;

    bb = piece [i];
    while (bb)
    {
        p = LSB (bb);
        j = bitscan (p);

        att = b_att (occ, j);
        att &= ~occ_own;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, (t & occ_opp) ? f_capture : 0, B);

            att ^= t;
        };

        bb ^= p;
    };

    // 
    i -= 2;

    bb = piece [i];
    while (bb)
    {
        p = LSB (bb);
        j = bitscan (p);

        att = knight_att [j];
        att &= ~occ_own;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, (t & occ_opp) ? f_capture : 0, B);

            att ^= t;
        };

        bb ^= p;
    };




    // 
    i -= 2;

    bb = piece [i];

    if (!wtm)
    {
        att = (bb & ~file_h) >> 7;
        att &= occ_opp;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 7, k, f_capture, B);
            else        generate_proms (i, k + 7, k, f_capture, B, m);

            att ^= t;
        };

        att = (bb & ~file_a) >> 9;
        att &= occ_opp;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 9, k, f_capture, B);
            else        generate_proms (i, k + 9, k, f_capture, B, m);

            att ^= t;
        };

        att = bb >> 8;
        att &= ~occ;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 8, k, 0, B);
            else        generate_proms (i, k + 8, k, 0, B, m);

            att ^= t;
        };

        att = (bb >> 16) & (~occ >> 8) & (~occ);
        att &= rank_5;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 16, k, f_2pawn, B);
            else        generate_proms (i, k + 16, k, f_2pawn, B, m);

            att ^= t;
        };

        //   
        ep = B->en_passant;
        if (ep)
        {
            bb = wpawn_att [ep] & piece [i];

            while (bb)
            {
                t = LSB (bb);
                j = bitscan (t);

                generate_moves (i, j, ep, f_ep, B);

                bb ^= t;
            };
        };
    }
    else
    {
        att = (bb & ~file_h) << 9;
        att &= occ_opp;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 9, k, f_capture, B);
            else        generate_proms (i, k - 9, k, f_capture, B, m);

            att ^= t;
        };

        att = (bb & ~file_a) << 7;
        att &= occ_opp;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 7, k, f_capture, B);
            else        generate_proms (i, k - 7, k, f_capture, B, m);

            att ^= t;
        };

        att = bb << 8;
        att &= ~occ;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 8, k, 0, B);
            else        generate_proms (i, k - 8, k, 0, B, m);

            att ^= t;
        };

        att = (bb << 16) & (~occ << 8) & (~occ);
        att &= rank_4;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 16, k, f_2pawn, B);
            else        generate_proms (i, k - 16, k, f_2pawn, B, m);

            att ^= t;
        };

        //   
        ep = B->en_passant;
        if (ep)
        {
            bb = bpawn_att [ep] & piece [i];

            while (bb)
            {
                t = LSB (bb);
                j = bitscan (t);

                generate_moves (i, j, ep, f_ep, B);

                bb ^= t;
            };
        };
    };

    return B->size;
};


int generate_attacks (board * B)
{
    int i, j, k;          //  , , 
    int m;               //    generate_proms ()
    U64 bb;
    U64 t, p, att, occ;
    U64 occ_own, occ_opp;

    B->msk_bb = U;
    B->pin_bb = E;

    B->taken = no_p;


    B->size = 0;

    occ_own = occupied [wtm];
    occ_opp = occupied [!wtm];

    occ = occ_own | occ_opp;

    ////////////////////////////
    check_detection (B);
    ////////////////////////////



    //  (    )
    i = BK + wtm;

    bb = piece [i];
    j = bitscan (bb);

    att = king_att [j];
    att &= ~occ_own;    //     

    att &= occ_opp;

    while (att)
    {
        t = LSB (att);
        k = bitscan (t);

        generate_moves (i, j, k, f_capture, B);

        att ^= t;
    };


    if (B->check_is > 0)
    {
        if (B->check_is > 1) return B->size;
        //    -   
        //      

        build_mask (B);
    };



    //   



    // 
    i -= 2;

    bb = piece [i];
    while (bb)
    {
        p = LSB (bb);
        j = bitscan (p);

        att = b_att (occ, j) | r_att (occ, j);
        att &= ~occ_own;

        att &= B->msk_bb;
        att &= occ_opp;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, f_capture, B);

            att ^= t;
        };

        bb ^= p;
    };


    // 
    i -= 2;

    bb = piece [i];
    while (bb)
    {
        p = LSB (bb);
        j = bitscan (p);

        att = r_att (occ, j);
        att &= ~occ_own;

        att &= B->msk_bb;
        att &= occ_opp;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, f_capture, B);

            att ^= t;
        };

        bb ^= p;
    };

    // 
    i -= 2;

    bb = piece [i];
    while (bb)
    {
        p = LSB (bb);
        j = bitscan (p);

        att = b_att (occ, j);
        att &= ~occ_own;

        att &= B->msk_bb;
        att &= occ_opp;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, f_capture, B);

            att ^= t;
        };

        bb ^= p;
    };

    // 
    i -= 2;

    bb = piece [i];
    while (bb)
    {
        p = LSB (bb);
        j = bitscan (p);

        att = knight_att [j];
        att &= ~occ_own;

        att &= B->msk_bb;
        att &= occ_opp;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            generate_moves (i, j, k, f_capture, B);

            att ^= t;
        };

        bb ^= p;
    };




    // 
    i -= 2;

    bb = piece [i];

    if (!wtm)
    {
        att = (bb & ~file_h) >> 7;
        att &= occ_opp;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 7, k, f_capture, B);
            else        generate_proms (i, k + 7, k, f_capture, B, m);

            att ^= t;
        };

        att = (bb & ~file_a) >> 9;
        att &= occ_opp;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H1) generate_moves (i, k + 9, k, f_capture, B);
            else        generate_proms (i, k + 9, k, f_capture, B, m);

            att ^= t;
        };

        att = bb >> 8;
        att &= ~occ;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A3)
            {
                if (k > H1) generate_moves (i, k + 8, k, 0, B);
                else        generate_proms (i, k + 8, k, 0, B, m);
            };

            att ^= t;
        };
    }
    else
    {
        att = (bb & ~file_h) << 9;
        att &= occ_opp;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 9, k, f_capture, B);
            else        generate_proms (i, k - 9, k, f_capture, B, m);

            att ^= t;
        };

        att = (bb & ~file_a) << 7;
        att &= occ_opp;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k < A8) generate_moves (i, k - 7, k, f_capture, B);
            else        generate_proms (i, k - 7, k, f_capture, B, m);

            att ^= t;
        };

        att = bb << 8;
        att &= ~occ;

        att &= B->msk_bb;

        while (att)
        {
            t = LSB (att);
            k = bitscan (t);

            if (k > H6)
            {
                if (k < A8) generate_moves (i, k - 8, k, 0, B);
                else        generate_proms (i, k - 8, k, 0, B, m);
            };

            att ^= t;
        };
    };

    return B->size;
};

int generate_legal (board * B) // Slow! Use carefully
{
    int i, sz;
    int legal = 0;
    int values [256];

    board * N = B->next;

    sz = generate (B);

    for (i = 0; i < sz; i ++)
    {
        if (make_move (i, B, N))
        {
            legal ++;
            values [i] = 1;
            unmake_move (i, B);
        }
        else values [i] = 0;
    };

    shell_sort ((int*)values, (int*)B->moves, sz);

    B->size = legal;

    return legal;
};

int make_move  (int i, board * B, board * N)
{
    int _piece;
    int piece_to, t;
    int _from, _to;
    int _toep, _flags;
    int t1, t2;
    U64 a1, a2;
    int mv;
    int old_irreversible = S->irreversible_ply;
    int old_fifty        = S->fifty;
    int old_count_moves  = S->count_moves;

    mv     = B->moves [i];

    _flags = (mv & 0x000000FF);
    _to    = (mv & 0x0000FF00) >> 8;
    _from  = (mv & 0x00FF0000) >> 16;
    _piece = (mv & 0xFF000000) >> 24;


    //          
    if ((_flags & f_mask) == f_castling)
    {
        U64 king_temp, occu_temp;

        t1 = N->check_is;
        t2 = N->attacker;

        //    
        king_temp = piece [_piece];
        occu_temp = occupied [wtm];

        //   3 ,   
        piece [_piece] = (I << _from);
        occupied [wtm] = occu_temp | piece [_piece];
        check_detection (N);

        if (N->check_is)
        {
            piece [_piece] = king_temp;
            occupied [wtm] = occu_temp;

            N->check_is = t1;
            N->attacker = t2;

            return 0;
        };

        piece [_piece] = link_att [_from][_to];
        occupied [wtm] = occu_temp | piece [_piece];
        check_detection (N);

        if (N->check_is)
        {
            piece [_piece] = king_temp;
            occupied [wtm] = occu_temp;

            N->check_is = t1;
            N->attacker = t2;

            return 0;
        };

        piece [_piece] = (I << _to);
        occupied [wtm] = occu_temp | piece [_piece];
        check_detection (N);

        if (N->check_is)
        {
            piece [_piece] = king_temp;
            occupied [wtm] = occu_temp;

            N->check_is = t1;
            N->attacker = t2;

            return 0;
        };

        piece [_piece] = king_temp;
        occupied [wtm] = occu_temp;

        N->check_is = t1;
        N->attacker = t2;
    };







    //if (L != N) N->en_passant = 0;

    N->hash_mat = B->hash_mat ^ hash_key_wtm;

    N->en_passant = 0;

    //     
    N->castling_rights = B->castling_rights
                       & un_castling [_from]
                       & un_castling [_to];






    switch (_flags & f_mask)
    {
        case f_2pawn: //       ////////////////////

        N->en_passant = (_from + _to) >> 1;

        //B->taken = no_p;

        a1 = (I << _from) | (I << _to);


        piece [_piece] ^= a1;

        occupied [wtm] ^= a1;

        squares [_to] = _piece;

        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [_piece][_to];

        S->irreversible_ply = S->count_moves;
        S->fifty = 0;

        break;

        case f_prom: //  //////////////////////////////////////////////////

        t = _flags & (~f_mask);
        t ++;
        t <<= 1;
        t += wtm; //  


        a1 = (I << _from);
        a2 = (I << _to);

        piece [_piece] ^= a1;
        piece [t]      ^= a2;

        occupied [wtm] ^= a1 | a2;

        squares [_to] = t;

        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [t][_to];

        mat [wtm] += material [t] - material [_piece];

        S->irreversible_ply = S->count_moves;
        S->fifty = 0;

        break;

        case f_prom | f_capture: //    ///////////////////////////////////////

        //   
        piece_to = squares [_to];

        B->taken = piece_to;

        a1 = (I << _to);

        piece [piece_to] ^= a1;

        occupied [!wtm]  ^= a1;

        t = _flags & (~f_mask);
        t ++;
        t <<= 1;
        t += wtm; //  


        a2 = (I << _from);

        piece [_piece]      ^= a2;
        piece [t]           ^= a1;

        occupied [wtm]      ^= a1 | a2;

        squares [_to] = t;

        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [piece_to][_to]
                    ^  hash_key [t][_to];

        mat [wtm] += material [t] - material [_piece];
        mat [!wtm] -= material [piece_to];

        S->irreversible_ply = S->count_moves;
        S->fifty = 0;

        break;

        case f_capture: //  ///////////////////////////////////////////////////////

        //   
        piece_to = squares [_to];

        B->taken = piece_to; //   

        a1 = (I << _to);
        a2 = (I << _from) | a1;

        piece [_piece]     ^= a2;
        piece [piece_to]   ^= a1;

        occupied [wtm]     ^= a2;
        occupied [!wtm]    ^= a1;

        squares [_to] = _piece;

        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [_piece][_to]
                    ^  hash_key [piece_to][_to];

        mat [!wtm] -= material [piece_to];

        S->irreversible_ply = S->count_moves;
        S->fifty = 0;

        break;

        case f_ep: //    ////////////////////////////////////////////

        // ,    
        _toep = (_to & 7) + (_from & 0xF8);

        t = _piece ^ 1;

        B->taken = t; //   

        a1 = (I << _from) | (I << _to);
        a2 = (I << _toep);

        piece [_piece]     ^= a1;
        piece [t]          ^= a2;

        occupied [wtm]     ^= a1;
        occupied [!wtm]    ^= a2;

        squares [_to] = _piece;

        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [_piece][_to]
                    ^  hash_key [t][_toep];

        mat [!wtm] -= material [t];

        S->irreversible_ply = S->count_moves;
        S->fifty = 0;

        break;

        case f_castling: //  ////////////////////////////////////////////////////

        if (_from > _to) // 
        {
            a1 = (I << _from) | (I << _to);
            a2 = (I << (_to - 2)) | (I << (_to + 1));

            piece [_piece]     ^= a1;
            piece [BR + wtm]   ^= a2;

            occupied [wtm]     ^= a1 | a2;

            squares [_to] = _piece;
            squares [_to + 1] = BR + wtm;


            N->hash_mat ^= hash_key [_piece][_from]
                        ^  hash_key [_piece][_to]
                        ^  hash_key [BR + wtm][_to - 2]
                        ^  hash_key [BR + wtm][_to + 1];

            //S->irreversible_ply = S->count_moves; //     ?

            break;
        };

        // 

        a1 = (I << _from) | (I << _to);
        a2 = (I << (_to + 1)) | (I << (_to - 1));

        piece [_piece]     ^= a1;
        piece [BR + wtm]   ^= a2;

        occupied [wtm]     ^= a1 | a2;

        squares [_to] = _piece;
        squares [_to - 1] = BR + wtm;


        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [_piece][_to]
                    ^  hash_key [BR + wtm][_to + 1]
                    ^  hash_key [BR + wtm][_to - 1];

        //S->irreversible_ply = S->count_moves; //     ?
        S->fifty ++;

        break;

        default: //   //////////////////////////////////////////////////

        //L->taken = no_piece;

        a1 = (I << _from) | (I << _to);

        piece [_piece]     ^= a1;
        occupied [wtm]     ^= a1;

        squares [_to] = _piece;

        N->hash_mat ^= hash_key [_piece][_from]
                    ^  hash_key [_piece][_to];

        //    
        if (_piece < 2)
        {
            S->irreversible_ply = S->count_moves;
            S->fifty = 0;
        }
        else S->fifty ++;

        break;
    };


    N->hash  =  N->hash_mat
             ^  hash_key_ep   [N->en_passant]
             ^  hash_key_cast [N->castling_rights];

    t1 = N->check_is;
    t2 = N->attacker;

    //    (    ?)
    check_detection (N);

    if (N->check_is) //  !
    {
        wtm ^= 1;
        S->ply ++;

        unmake_move (i, B);

        N->check_is = t1;
        N->attacker = t2;

        S->irreversible_ply = old_irreversible;
        S->fifty            = old_fifty;
        S->count_moves      = old_count_moves;

        return 0;
    };

    N->check_is = t1;
    N->attacker = t2;

    wtm ^= 1;

    S->count_moves ++;

    //         (unmake_move)
    R[S->count_moves].irreversible_last = S->irreversible_ply;

    //  -    
    R[S->count_moves].key = N->hash;

    S->ply ++;

    return mv;
};


void unmake_move (int i, board * B)
{
    int _piece;
    int piece_to, t;
    int _from, _to;
    int _toep, _flags;
    U64 a1, a2;
    int mv;

    S->ply --;

    wtm ^= 1;

    S->count_moves --;

    //      50      
    S->fifty = S->irreversible_ply - R[S->count_moves].irreversible_last - 1;
    S->irreversible_ply = R[S->count_moves].irreversible_last;

    //     
    R[S->count_moves + 1].key = E;
    R[S->count_moves + 1].irreversible_last = 0;


    mv     = B->moves [i];

    _flags = (mv & 0x000000FF);
    _to    = (mv & 0x0000FF00) >> 8;
    _from  = (mv & 0x00FF0000) >> 16;
    _piece = (mv & 0xFF000000) >> 24;

    //if (_piece < 0 || _piece > 11) uci_send ("unknown piece\n");


    switch (_flags & f_mask)
    {
        case f_2pawn:             goto L_2;
        case f_prom:              goto L_p;
        case f_prom | f_capture:  goto L_pc;
        case f_capture:           goto L_c;
        case f_ep:                goto L_ep;
        case f_castling:          goto L_cast;
        default:                  goto L_default;
    };

    //       ////////////////////
L_2:
    B->taken = no_p;

    a1 = (I << _from) | (I << _to);

    piece [_piece]     ^= a1;

    occupied [wtm]     ^= a1;

    squares [_from] = _piece;

    return;

    //  //////////////////////////////////////////////////
L_p:
    t = _flags & (~f_mask);
    t ++;
    t <<= 1;
    t += wtm; //  

    a1 = (I << _from);
    a2 = (I << _to);

    piece [_piece]     ^= a1;
    piece [t]          ^= a2;

    occupied [wtm]     ^= a1 | a2;

    squares [_from] = _piece;

    mat [wtm] -= material [t] - material [_piece];

    return;

    //    ///////////////////////////////////////
L_pc:
    piece_to = B->taken;

    a1 = (I << _to);

    piece [piece_to] ^= a1;

    occupied [!wtm]  ^= a1;

    t = _flags & (~f_mask);
    t ++;
    t <<= 1;
    t += wtm; //  

    a2 = (I << _from);

    piece [_piece]     ^= a2;
    piece [t]          ^= a1;

    occupied [wtm]     ^= a1 | a2;

    squares [_from] = _piece;
    squares [_to] = piece_to;

    mat [wtm] -= material [t] - material [_piece];
    mat [!wtm] += material [piece_to];

    return;

    //  ///////////////////////////////////////////////////////
L_c:
    piece_to = B->taken;

    a1 = (I << _to);
    a2 = (I << _from) | a1;

    piece [_piece]     ^= a2;
    piece [piece_to]   ^= a1;

    occupied [wtm]     ^= a2;
    occupied [!wtm]    ^= a1;

    squares [_from] = _piece;
    squares [_to] = piece_to;

    mat [!wtm] += material [piece_to];

    return;

    //    ////////////////////////////////////////////
L_ep:
    // ,    
    _toep = (_to & 7) + _from - (_from & 7);

    t = _piece ^ 1;

    a1 = (I << _from) | (I << _to);
    a2 = (I << _toep);

    piece [_piece]     ^= a1;
    piece [t]          ^= a2;

    occupied [wtm]     ^= a1;
    occupied [!wtm]    ^= a2;

    squares [_from] = _piece;
    squares [_toep] = t;

    mat [!wtm] += material [t];

    return;

    //  ////////////////////////////////////////////////////
L_cast:
    if (_from > _to) // 
    {
        a1 = (I << _from) | (I << _to);
        a2 = (I << (_to - 2)) | (I << (_to + 1));

        piece [_piece]     ^= a1;
        piece [BR + wtm]   ^= a2;

        occupied [wtm]     ^= a1 | a2;

        squares [_from] = _piece;
        squares [_to - 2] = BR + wtm;

        return;
    };

    // 

    a1 = (I << _from) | (I << _to);
    a2 = (I << (_to + 1)) | (I << (_to - 1));

    piece [_piece]     ^= a1;
    piece [BR + wtm]   ^= a2;

    occupied [wtm]     ^= a1 | a2;

    squares [_from] = _piece;
    squares [_to + 1] = BR + wtm;

    return;

    //   //////////////////////////////////////////////////
L_default:
    a1 = (I << _from) | (I << _to);

    piece [_piece] ^= a1;

    occupied [wtm] ^= a1;

    squares [_from] = _piece;
};

void make_null  (board * B, board * N)
{
    N->castling_rights = B->castling_rights;
    N->en_passant = 0;
    N->hash  =  B->hash
             ^  hash_key_ep   [B->en_passant] /////////////////////// (!)
             ^  hash_key_wtm;

    wtm ^= 1;
    S->ply ++;

    S->fifty ++;
    S->count_moves ++;

    //         (unmake_move)
    R[S->count_moves].irreversible_last = S->irreversible_ply;

    //  -    
    R[S->count_moves].key = N->hash;
};

void unmake_null  ()
{
    wtm ^= 1;
    S->ply --;

    S->count_moves --;

    //      50      
    S->fifty = S->irreversible_ply - R[S->count_moves].irreversible_last - 1;
    S->irreversible_ply = R[S->count_moves].irreversible_last;

    //     
    R[S->count_moves + 1].key = E;
    R[S->count_moves + 1].irreversible_last = 0;
};

int threefold_repetition (board * B)
{
    int i;
    int count = 0;

    for (i = S->count_moves - 2; i > S->irreversible_ply; i -= 2)
    {
        if (B->hash == R[i].key)
        {
            count ++;
            if (count > 0) return 1;
        };
    };

    return 0;
};

/*
//    
bool InsufficientMaterial()
{
	// , ,  
	if (WhitePawns || WhiteQueens || WhiteRooks) return false;
	if (BlackPawns || BlackQueens || BlackRooks) return false;

	uint8 cnt = PopCnt(WhitePieces | BlackPieces);

	//    
	if (cnt < 4) return true;

	//   
	if (cnt == 4 && WhiteBishops && BlackBishops)
	{
		uint8 wsq = LSB(WhiteBishops);
		uint8 bsq = LSB(BlackBishops);
		if ((File(wsq) + Rank(wsq) & 1) == (File(bsq) + Rank(bsq) & 1)) return true;
	}
	return false;
}
*/

















