#include "main.h"

void hash_refresh ()
{
    int i;
    hash_t* h;

    for (i = 0; i < H->size; i ++)
	{
	    h = &H->entry [i];

        h->age   = 0;
	    h->depth = 0;
	    h->key   = E;
	    h->move  = 0;
	    h->score = 0;
	    h->type  = 0;
	};
};

void reps_refresh ()
{
    int i;

    for (i = 0; i < REP_TABLE; i ++)
	{
	    R[i].key = E;
	    R[i].irreversible_last = 0;
	};
}

hash_t* hash_get (board * B)
{
    hash_t* h;
    U64 index;

    index = B->hash & (H->size - 1);
    h = &H->entry [index];
    if (h->key == B->hash) return h;

    return NULL;
};

U64 hash_calc (board * B)
{
	int i, j;
	U64 bb, t;
	U64 h;

	h = E;

	for (i = 0; i < 12; i ++)
	{
		bb = piece [i];

		while (bb)
		{
			t = LSB (bb);
			j = bitscan (t);

			h ^= hash_key [i][j];

			bb ^= t;
		};
	};

	if (wtm) h ^= hash_key_wtm;

	B->hash_mat = h;

	h ^= hash_key_ep   [B->en_passant];
	h ^= hash_key_cast [B->castling_rights];

	return h;
};

void hash_update (int mv, int score, int type, int depth, board * B)
{
	hash_t* h;
    U64 index;

    index = B->hash & (H->size - 1);
    h = &H->entry [index];

	if (h->age == g_hash_age && h->depth > depth) return;

	if      (score >   mate) score += S->ply;
	else if (score < - mate) score -= S->ply;

	h->age   = g_hash_age;
	h->depth = depth;
	h->score = score;
	h->key   = B->hash;
	h->move  = mv;
	h->type  = type;
};


void hash_retrieve (int &alpha, int &beta, int &mv, int depth, board * B)
{
    int score;
    hash_t * h = hash_get (B);

	if (h != NULL)
	{
		mv = h->move;

		if (h->age != g_hash_age || h->depth <= depth) return;

        score = h->score;

        if      (score >   mate) score -= S->ply;
        else if (score < - mate) score += S->ply;


        // Thanks to CPW
        if (h->type == HASH_EXACT) //  
        {
            alpha = beta = score;
        }
        else if (h->type == HASH_ALPHA) //  
        {
            if (score <= alpha) alpha = score;
        }
        else if (h->type == HASH_BETA) //  
        {
            if (score >= beta) beta = score;
        };
	}
	else mv = 0; //   
};
